
//	Copyright 2010 PaletteSoft LLC

//	******  ******* *     * *******  *****  *******                           
//	*     * *       *     *    *    *     * *                                 
//	*     * *       *     *    *    *       *                                 
//	*     * ******* *     *    *    *       *******                           
//	*     * *        *   *     *    *       *                                 
//	*     * *         * *      *    *     * *                                 
//	******  *******    *    *******  *****  *******                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	003 2010.08.07
//	ESHT-11 C^[tF[XI[vhCɑΉ
// ---------------------------------------------------------------------------
//	002 2010.07.30
//	EUSARTɂRS232CʐMɕύXB
// ---------------------------------------------------------------------------
//	001 2010.05.16
//	EVK쐬@PIC 16F886 3.3V 쓮pɕύX@by@A.Ohta
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************
// ***************************************************************************

	//	*****  *****

#include	<htc.h>														//	vWFNgݒőIꂽfoCXIɈp܂

	//	***** 錾 *****

#include	"_AtrDef.h"													//	萔Af[^^̐錾

	//	*****  *****

#include	"version.h"													//	o[Wԍ̒`

#include	"device.h"													//	foCX

#include	"nokiaGlcdlib.h"											//  LCD
// ***************************************************************************
// *	zdl															 *
// ***************************************************************************
/*
	CZT]TvvO			PIC18F2550 CLOCK:16MHz Vdd = 3.3V
	ӁFdd̍ő͂RDRu܂		SCP1000-D01	High resolution mode
	xZT]TvvO			SHT-11 Vdd = 3.3V

	RA0:MOSI		PIC -> SCP		Mf[^
	RA1:SCK			PIC -> SCP		NbN
	RA2:SW1			PIC <- SW1		SW1
	RA3:MISO		PIC <- SCP		Mf[^
	RA4:CSB			PIC -> SCP		`bvZNg
	RA5:(INV)RES	PIC -> GLCD		(INV)Zbg

	RB0:DRDY		PIC <- SCP		f[^ZbgiオGbWO INT0 𗘗pj
	RB1:D/C			PIC -> GLCD		f[^/R}hIM
	RB2:SCK			PIC -> SHT-11	f[^/R}hIM
	RB3:DATA		PIC <-> SHT-11	DATAo
	RB4:DSW4		PIC <- DSW4		fBbvSW4
	RB5:DSW5		PIC <- DSW5		fBbvSW5
	RB6:DSW6		PIC <- DSW6		fBbvSW6
	RB7:DSW7		PIC <- DSW7		fBbvSW7

	RC0:(INV)SCE	PIC -> GLCD		(INV)`bvZNg
	RC1:SDIN		PIC -> GLCD		Mf[^
	RC2:SLCK		PIC -> GLCD		NbN

	RC6:TXD			PIC -> ext		VAʐMMf[^iVCCxj

	ECZTƂ̒ʐMC^tF[X͂rohʐMB
	Ef[^Zbg̔F̓|[Oi荞ݗvtÔ݈pjB
	EʃVXeɂ͖{u璲ʐMőM̂݁B
	ECZT̓ɈˑēBf[^ZbggKƂēB
	EʐMx͂PXQOOAWrbgApeB
	EOtBbNLCDƂ̒ʐMC^tF[X͂rohʐMB

*/

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  ***** 16MHz (EXT8MHz HSPLL 1/2->4 -> 96-> 1/6 -> 16MHz SYSTEM NbN)

__CONFIG(1, FCMDIS & IESODIS & HSPLL & PLLDIV2 & PLLPOSTDIV6);
__CONFIG(2, BORDIS & BORV20 & PWRTEN & WDTDIS);
__CONFIG(3, CCP2RC1 & PBDIGITAL & LPT1DIS );
__CONFIG(4, DEBUGDIS & LVPDIS & STVREN);
__CONFIG(5, 0xFFFF);
__CONFIG(6, 0xFFFF);
__CONFIG(7, 0xFFFF);


	//	***** hc *****

	//	***** U *****

#define	_XTAL_FREQ			16000000									//	giSYSTEMNbNj

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

/*
	ʐM[hɂ钲ʐMi񓯊jł̒ʐMx͈ȉ̎ŎZoB
	bps = Fosc / (16 * (X + 1))
	16 * (X + 1) = Fosc / bps
	X + 1 = (Fosc / bps) / 16 = Fosc / (bps * 16)
	X = (Fosc / (bps * 16)) - 1

	iPjPXQOȌꍇ
		Fosc = 16000000
		bps =  9600, X = 51.083 = 51
		Fosc / (16 * (51 + 1)) = 19230.7692bps -> +0.160%
		19230bps ->  520us/byte									50char = 26ms	̃^CAEgԂlƁuvI

	iQjXUOȌꍇ
		Fosc = 16000000
		bps =  9600, X = 103.17 = 103
		Fosc / (16 * (103 + 1)) =  9615.4bps -> +0.160%			50char = 52ms
		 9615bps -> 1040us/byte
*/

#if 1																	//	PFPXQOOAOFXUOO
#define	UART_SPEED				51										//	PXQOOڕW
#else
#define	UART_SPEED				103										//	@XUOOڕW
#endif

// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************

	//	***** |[gf[^ *****

typedef	union {
	UB		BYTE;
	struct {															//								@l
		_UINT	MOSI	: 1;											//	OFMf[^				ó@O	kraFrbg̕тɒ
		_UINT	SCK		: 1;											//	PFNbN					ó@O
		_UINT	_dummy2	: 1;											//	QFij				||@|
		_UINT	MISO	: 1;											//	RFMf[^				́@P
		_UINT	CSB		: 1;											//	SF`bvZNg				ó@O
		_UINT	_dummy5	: 1;											//	TFij				||@|
		_UINT	_dummy6	: 1;											//	UFij				||@|
		_UINT	_dummy7	: 1;											//	VFij				||@|
	} BIT;
} uPort;

#define	SIG_DRDY				(BIT02)									//	Mǂݏo}XNpFf[^Zbg
#define	SIG_MISO				(BIT03)									//	Mǂݏo}XNpFMf[^

//								  76543210
#define	INIT_PORTA_DATA			0b00110000 								//	|[gf[^
#define	INIT_PORTA_DIR			0b00001100 								//	|[go͕
#define	INIT_PORTB_DIR			0b11111001 								//	|[go͕

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************
// ***************************************************************************

uPort	vDevPort;														//	|[gf[^̃obNAbv

// ***************************************************************************
// ***************************************************************************
// *	e[u															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************
// ***************************************************************************

	//	***** M *****

void	DevSigPutMOSI_H(void);
void	DevSigPutMOSI_L(void);
void	DevSigPutSCK_H(void);
void	DevSigPutSCK_L(void);

UB		DevSigGetMISO(void);

	//	***** ʐM *****

void	DevComBrtStart(void);
void	DevComBrtStop(void);
void	DevComSendBit(UB Data);
void	DevComWaitSend(void);

// ***************************************************************************
// ***************************************************************************
// *	{															 *
// ***************************************************************************
// ***************************************************************************

//	
//	
//
// 		{
//
//	
//	
void	DevStd______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ohb}CRݒ肵܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****											//	ӁFȑÕTvvOɔ׃Rg̃rbg̕тt]Ă܂

	//	***** 荞݊ *****										//	f[^ZbgɂO荞ݑΉɔďݒ̂ݍs

//						  76543210
	INTCON = 			0b00000000;										//	荞ݐ䃌WX^i荞݋֎~Avj
																		//	bit00:GPIF		0	ėp̓|[gω荞ݖ		gp
																		//	bit01:INTF		0	O荞ݖ					
																		//	bit02:T0IF		0	^C}OI[ot[荞ݖ	gp
																		//	bit03:GPIE		0	ėp̓|[gω荞݋֎~		gp
																		//	bit04:INTE		0	O荞݋֎~					
																		//	bit05:T0IE		0	^C}OI[ot[荞݋֎~	gp
																		//	bit06:PEIE		0	ytF荞݋֎~			gp
																		//	bit07:GIE		0	Ă̊荞݋֎~					

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

	vDevPort.BYTE = INIT_PORTA_DATA;									//	ėpo̓|[gf[^̏lݒ
	PORTA = vDevPort.BYTE;												//	WX^ݒ

	ADCON1 = 0b00001111;												// @AiO̓|[gSăfW^I/O|[gɊtݒ肷iPORTAj@ǉ
	TRISA  = INIT_PORTA_DIR;											//	PORTAo͕WX^
	TRISB  = INIT_PORTB_DIR;											//  PORTBo͕WX^ ǉ
}

//	
//	
//
// 		M
//
//	
//	
void	DevSig______(void) {}											//	op֐

//============================================================================
//	CZTւ̏o
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	CZTւ̐M𐧌䂵܂B
//============================================================================
void	DevSigPutMOSI_H(void)	{	vDevPort.BIT.MOSI = 1;		PORTA = vDevPort.BYTE;	}
void	DevSigPutMOSI_L(void)	{	vDevPort.BIT.MOSI = 0;		PORTA = vDevPort.BYTE;	}

void	DevSigPutSCK_H(void)	{	vDevPort.BIT.SCK  = 1;		PORTA = vDevPort.BYTE;	}
void	DevSigPutSCK_L(void)	{	vDevPort.BIT.SCK  = 0;		PORTA = vDevPort.BYTE;	}

void	DevSigPutCSB_H(void)	{	vDevPort.BIT.CSB  = 1;		PORTA = vDevPort.BYTE;	}
void	DevSigPutCSB_L(void)	{	vDevPort.BIT.CSB  = 0;		PORTA = vDevPort.BYTE;	}

//============================================================================
//	CZT̓
//----------------------------------------------------------------------------
//	́F	
//	óF	M̏ԁiOFkAOFgj
//----------------------------------------------------------------------------
//	lF	CZT̐M͂܂B
//============================================================================
UB		DevSigGetMISO(void)		{	return(PORTA & (UB)SIG_MISO);	}

//============================================================================
//	CZT̃f[^Zbg󋵂̎擾
//----------------------------------------------------------------------------
//	́F	
//	óF	f[^Zbg󋵁isqtd^e`krdj
//----------------------------------------------------------------------------
//	lF	CZTf[^łƂf[^ZbgM̗
//			GbW̌o󋵂擾܂B
//			M̗オGbWoꍇ̓NAs܂B
//============================================================================
BOOL	DevSigGetDRDY_Edge(void)
{
	UB		Result = FALSE;												//	ʂ̓GbW𖢌oŏ

	if (RB0) {														//	O荞 RB0(INT0) ̗オGbWo
		RB0 = 0;														//	oԂ
		Result = TRUE;													//	GbWoŃf[^Zbg
	}

	return(Result);														//	ʂԂ܂
}

//	
//	
//
// 		ʐM
//
//	
//	
void	DevCom______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʐMݒ肵܂B
//			rbg[g𓱂o߂Ƀ^C}Qgp܂B̃^C}Q̃^
//			CAEgԊuPrbgʐMԂɑ܂B
//============================================================================
void	DevComInit(void)
{
	//	***** rbg[g^C}ݒ *****

//			  76543210
	T2CON = 0b00000001;													//	^C}Q䃌WX^
																		//	bit00 T2CKPS0	0	vXP[͂PFS
																		//	bit01 T2CKPS1	0	@ij
																		//	bit02 TMR2ON	0	^C}Q~
																		//	bit03 TOUTPS0	0	|XgXP[͂PFP
																		//	bit04 TOUTPS1	0	@ij
																		//	bit05 TOUTPS2	0	@ij
																		//	bit06 TOUTPS3	0	@ij
																		//	bit07 -----

	//	***** {ݒ *****

//				  76543210
	TXSTA =		0b00000000;												//	MXe[^XARg[WX^
																		//	b0:TX9D		0	M̂XrbgڏipeBƂėp\j
																		//	b1:TRMT		0	ǂݎpFVtgWX^󂫃t󋵂ʒm
																		//	b2:BRGH		0	ᑬʐM[hiʐMxݒ莞ɗpj
																		//	b3:-----	0	
																		//	b4:SYNC		0	i񓯊jʐM[hiʐMł͖j
																		//	b5:TXEN		0	M~
																		//	b6:TX9		0	WrbgM[h
																		//	b7:CSRC		0	X[u[hiʐMł͖Ӗj

//				  76543210
	RCSTA =		0b10000000;												//	MXe[^XARg[WX^
																		//	b0:RX9D		0	ǂݎpFM̂XrbgڏipeBƂėp\j
																		//	b1:OERR		0	ǂݎpFI[o[G[ʒm
																		//	b2:FERR		0	ǂݎpFt[~OG[ʒm
																		//	b3:ADEN		0	AhXoiXrbgڂ̓peBƂėp\j
																		//	b4:CREN		0	AM֎~iʐMł̈Ӗj
																		//	b5:SREN		0	PM֎~iʐMł͖Ӗj
																		//	b6:RX9		0	WrbgM[h
																		//	b7:SPEN		1	VA|[gLiRC6ARC7TXDARXDƂėpj

	//	***** ʐMxݒ *****

	BRGH = 1;															//	ʐM[h
	SPBRG = UART_SPEED;													//	ʐMxݒ

	//	***** 荞ݐݒ *****

	RCIE = 0;															//	M荞݋֎~
	TXIE = 0;															//	Mobt@󊄂荞݋֎~

	//	***** ʐMJn *****

	TXEN = 1;															//	M							@łswhePɂȂ
	CREN = 0;															//	AMȂ				//  ύX

}

//============================================================================
//	obt@̑M
//----------------------------------------------------------------------------
//	́F	obt@AhX
//	óF	
//----------------------------------------------------------------------------
//	lF	obt@Ɋi[镶R[h𑗐M܂B
//============================================================================
void	DevComSendData(const UB *Buffer)
{
	UB		Data;														//	Mf[^

	while (1) {															//	obt@𑍂đM

		if ((Data = *Buffer) == CODE_NUL) {								//	obt@ǂݏo當I[oH
			break;														//	Eo
		}
		Buffer ++;														//	obt@AhXXV

		while (TXIF == 0) {												//	Mobt@iswqdfj܂őҋ@
			;															//	őPoCgʐMԂҋ@
		}

		TXREG = Data;													//	Mf[^ZbgiWrbg[hȂ̂ŃpeB͕svj
	}
}

//	
//	
//
// 		Ԑ
//
//	
//	
void	DevTim______(void) {}											//	op֐

//============================================================================
//	~bPʂ̑ҋ@
//----------------------------------------------------------------------------
//	́F	ҋ@ԁiO`QTTj
//	óF	
//----------------------------------------------------------------------------
//	lF	\tgEFA^C}𗘗pҋ@s܂B
//============================================================================
void	DevTimWaitMs(UB Time)
{
	while (Time --) {													//	ҋ@Ԃ菄
		__delay_ms(1);													//	Pҋ@
	}
}

//	
//	
//
// 		roh
//
//	
//	
void	DevSpi______(void) {}											//	op֐

	//	***** M *****

#define	mSpiClk_L()				DevSigPutSCK_L()						//	NbNMk								
#define	mSpiClk_H()				DevSigPutSCK_H()						//	NbNMg

#define	mSpiOut_L()				DevSigPutMOSI_L()						//	o̓f[^k								
#define	mSpiOut_H()				DevSigPutMOSI_H()						//	o̓f[^g

#define	mSpiIn()				DevSigGetMISO()							//	̓f[^iOAOŔfj

	//	***** Ԑ *****

#define	mSpiWaitTDS()								 					//	f[^ZbgAbvԁi̎ԑҋ@ANbNMgɐ؂ւj

#define	mSpiWaitTCH()								 					//	NbNMgێ
#define	mSpiWaitTCL()													//	NbNMkێ

//============================================================================
//	Mݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	rohʐMŎgpo͐Mݒ肵܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
void	DevSpiInit(void)
{
	mSpiClk_L();														//	NbNMk
	mSpiOut_L();														//	o̓f[^Mk
}

//============================================================================
//	CӃrbg̑M
//----------------------------------------------------------------------------
//	́F	Mf[^
//	óF	
//----------------------------------------------------------------------------
//	lF	Mf[^̂lra珇ԂɃrbg̑Ms܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
void	DevSpiPutData(UB Data)
{
	UB		Number = 8;													//	Mrbg

	//	***** M *****

	while (Number --) {													//	MrbgJԂ

		//	***** f[^o *****

		if (Data & (UB)0x80) {											//	lraPH
			mSpiOut_H();												//	o̓f[^g
		}
		else {															//	lraO
			mSpiOut_L();												//	o̓f[^k
		}
		mSpiWaitTDS();													//	ҋ@Ff[^ZbgAbv

		//	***** NbN *****

		mSpiClk_H();													//	NbNMg
		mSpiWaitTCH();													//	ҋ@FNbNg

		mSpiClk_L();													//	NbNMk
		mSpiWaitTCL();													//	ҋ@FNbNk

		//	***** ̃rbg *****

		Data <<= 1;														//	PrbgVtg
	}
}

//============================================================================
//	Wrbg̎M
//----------------------------------------------------------------------------
//	́F	
//	óF	Mf[^
//----------------------------------------------------------------------------
//	lF	Wrbg̃f[^lraMĕԂ܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
UB		DevSpiGetData(void)
{
	UB		Number = 8;													//	Mrbg
	UB		Data = 0;													//	Mf[^

	//	***** M *****

	while (Number --) {													//	MrbgJԂ

		//	***** ̃rbg *****

		Data <<= 1;														//	PrbgVtg

		//	***** f[^ *****

		if (mSpiIn()) {													//	̓f[^͂gH
			Data |= (UB)0x01;											//	̍
		}
//*		mSpiWaitTDS();													//	ҋ@Ff[^ZbgAbv	{sv

		//	***** NbN *****

		mSpiClk_H();													//	NbNMg
		mSpiWaitTCH();													//	ҋ@FNbNg

		mSpiClk_L();													//	NbNMk
		mSpiWaitTCL();													//	ҋ@FNbNk
	}

	//	***** ܂ *****

	return(Data);														//	Mf[^Ԃ܂
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

