/*
		mLA5110LCD쓮pCu[

	RC0:(INV)SCE	(INV)LCD `bvCl[u
	RC1:SDIN		f[^
	RC2:SCK			ʐMpNbN
	RC3:D/(INV)C	f[^/(INV)R}h IM
	RC4:(INV)RES	(INV)LCD Zbg

*/

// 	DIP_SW@|[g`

#define DIP_SW4			RB4												//  
#define DIP_SW3			RB5												//  
#define DIP_SW2			RB6												//  
#define DIP_SW1			RB7												//  


// 48~84hbgOtBbNLCD@|[g`

#define SPI_SCE			RC0												//  (INV)SCE
#define SPI_DATA		RC1												//  SDIN
#define SPI_CLK			RC2												//  SCK
#define SPI_DC			RB1												//  D/(INV)C
#define SPI_RES			RA5												//  (INV)RES

#define LCD_WIDTH		84
#define LCD_HEIGHT		48
#define LCD_BANKS		(LCD_HEIGHT/8)
#define LCD_MAX_X		(LCD_WIDTH  - 1)
#define LCD_MAX_Y		(LCD_HEIGHT - 1)
#define LCD_MAX_BANK	(LCD_BANKS - 1)

#define LCD_MAX_PRES	1025											//  \C̍ől
#define LCD_MIN_PRES	977												//  \C̍ŏl

#define LCD_MAX_TEMP	50												//  \鉷x̍ől
#define LCD_MIN_TEMP	0												//  \鉷x̍ŏl

#define GRAPH_HIST_MAX	48

// vg^Cv錾

void SPI_tx_byte(unsigned char, int);
void SPI_tx_data(unsigned char);
void SPI_tx_command(unsigned char);

void LCD_init();
void LCD_locate(unsigned char, unsigned char);
void LCD_set_data(unsigned char *, int);
void LCD_clear(unsigned int);

void print_num(int, int, int);
void print_unithps(void);
void print_percent(void);
void print_unitdeg(void);
void print_Yaxis(void);
void graph_plotx_clear(int);
void print_press(int);
void print_temp(int, int);
void print_RH(int);
void print_pdhgraph(int, int, int, int);
void draw_point(int, int);
void draw_pdhpoint(int, int, int, int);


int		gX;																//  Graph Plot X posision
int		gintT;															//  Graph Plotting Interbal Tim
int		gcount;															//  Graph Plotting tnterbal time count
